/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   paper-radio-group.html
 */

/// <reference path="../polymer/types/polymer.d.ts" />
/// <reference path="../iron-a11y-keys-behavior/iron-a11y-keys-behavior.d.ts" />
/// <reference path="../iron-menu-behavior/iron-menubar-behavior.d.ts" />
/// <reference path="../paper-radio-button/paper-radio-button.d.ts" />

/**
 * Material design: [Radio button](https://www.google.com/design/spec/components/selection-controls.html#selection-controls-radio-button)
 *
 * `paper-radio-group` allows user to select at most one radio button from a set.
 * Checking one radio button that belongs to a radio group unchecks any
 * previously checked radio button within the same group. Use
 * `selected` to get or set the selected radio button.
 *
 * The <paper-radio-buttons> inside the group must have the `name` attribute
 * set.
 *
 * Example:
 *
 *     <paper-radio-group selected="small">
 *       <paper-radio-button name="small">Small</paper-radio-button>
 *       <paper-radio-button name="medium">Medium</paper-radio-button>
 *       <paper-radio-button name="large">Large</paper-radio-button>
 *     </paper-radio-group>
 *
 * Radio-button-groups can be made optional, and allow zero buttons to be selected:
 *
 *     <paper-radio-group selected="small" allow-empty-selection>
 *       <paper-radio-button name="small">Small</paper-radio-button>
 *       <paper-radio-button name="medium">Medium</paper-radio-button>
 *       <paper-radio-button name="large">Large</paper-radio-button>
 *     </paper-radio-group>
 *
 * See <a href="paper-radio-button">paper-radio-button</a> for more
 * information about `paper-radio-button`.
 *
 *
 * Custom property | Description | Default
 * ----------------|-------------|----------
 * `--paper-radio-group-item-padding` | The padding of the item | `12px`
 */
interface PaperRadioGroupElement extends Polymer.Element, Polymer.IronMenubarBehavior {

  /**
   * Overriden from Polymer.IronSelectableBehavior
   */
  attrForSelected: string|null|undefined;

  /**
   * Overriden from Polymer.IronSelectableBehavior
   */
  selectable: string|null|undefined;

  /**
   * Overriden from Polymer.IronSelectableBehavior
   */
  selectedAttribute: string|null|undefined;

  /**
   * If true, radio-buttons can be deselected
   */
  allowEmptySelection: boolean|null|undefined;

  /**
   * Selects the given value.
   */
  select(value: any): void;
  _onUpKey(event: any): void;
  _onDownKey(event: any): void;
  _onLeftKey(event: any): void;
  _onRightKey(event: any): void;
  _activateFocusedItem(): void;
}

interface HTMLElementTagNameMap {
  "paper-radio-group": PaperRadioGroupElement;
}
